module Store
  module Api
    class AppsController < Store::ApplicationController
      respond_to :json

      #skip_before_action :verify_authenticity_token
      skip_before_action :set_user

      def index
        p = params.to_unsafe_h.except(:format, :controller, :action, :uuid, :space, :auth_token)
        query = ::Search::AppsSearch.new(p)
        @records = query.search.where(public_read: true)
                       .paginate(:page => params[:page])
        paginate @records, each_serializer: PublicAppSerializer
      end

      def show
        if app = App.find_by(id: params[:id])
          code=nil
          if params[:token] && peer = Peer.active.find_by(token: params[:token])
            if voucher=Voucher.find_by(host: peer.host, module: app.package, type: 'app')
              code=voucher.code
            end
          end
          render jsonapi: app, serializer: PublicAppSerializer, code: code
        else
          render_json_error :not_found, :app_not_found
        end
      end
    end
  end
end